#include <Wire.h>

#define SLAVE_ADDRESS 0x10
#define SERIAL_BAUD 9600

int DATA_SIZE, main_ver, minor_ver, error, state;
int ranging_mm = 0;

void setup()
{
  Wire.begin();
  Serial.begin(SERIAL_BAUD);
  Read_ver();
  delay(1000);
  Start_CMD();
}

void loop()
{
  Do_Ranging();
  Get_States();
  Serial.println();
}

void Read_ver()
{
  Wire.beginTransmission(SLAVE_ADDRESS);
  Wire.write(0x18);
  Wire.endTransmission(true);

  DATA_SIZE = 4;
  Wire.requestFrom(SLAVE_ADDRESS, DATA_SIZE);
  if (Wire.available()) {
    int i = 0, data_temp[4] = {0};
    while (Wire.available())
    {
      data_temp[i] = Wire.read();
      //      Serial.print( data_temp[i] , HEX);
      //      Serial.print(" ");
      i++;
    }

    main_ver = (data_temp[1] << 8) + data_temp[0];
    Serial.print( "Version: Main : ");
    Serial.print( main_ver , DEC);
  }



  Wire.beginTransmission(SLAVE_ADDRESS);
  Wire.write(0x19);
  Wire.endTransmission(true);

  DATA_SIZE = 4;
  Wire.requestFrom(SLAVE_ADDRESS, DATA_SIZE);
  if (Wire.available()) {
    int i = 0, data_temp[4] = {0};
    while (Wire.available())
    {
      data_temp[i] = Wire.read();
      //      Serial.print( data_temp[i] , HEX);
      //      Serial.print(" ");
      i++;
    }

    minor_ver = (data_temp[1] << 8) + data_temp[0];
    Serial.print( " Minor : ");
    Serial.println( minor_ver , DEC);
  }
}

void Start_CMD()
{
  //Ranging start
  Wire.beginTransmission(SLAVE_ADDRESS);
  Wire.write(0x02);
  Wire.write(0x01);
  Wire.write(0x00);
  Wire.endTransmission(true);
}

void Do_Ranging()
{
  //Read data
  Wire.beginTransmission(0x10);
  Wire.write(0x00);
  Wire.endTransmission();

  DATA_SIZE = 4;
  Wire.requestFrom(SLAVE_ADDRESS, DATA_SIZE);
  if (Wire.available()) {
    int i = 0, data_temp[4] = {0};
    while (Wire.available())
    {
      data_temp[i] = Wire.read();
      //      Serial.print( data_temp[i] , HEX);
      //      Serial.print(" ");
      i++;
    }

    ranging_mm = (data_temp[1] << 8) + data_temp[0];
    Serial.print( ranging_mm , DEC);
    Serial.print( " mm");
  }
}

void Get_States()
{
  //Read data
  Wire.beginTransmission(0x10);
  Wire.write(0x01);
  Wire.endTransmission();

  DATA_SIZE = 4;
  Wire.requestFrom(SLAVE_ADDRESS, DATA_SIZE);
  if (Wire.available()) {
    int i = 0, data_temp[4] = {0};
    while (Wire.available())
    {
      data_temp[i] = Wire.read();
//      Serial.print( data_temp[i] , HEX);
//      Serial.print(" ");
      i++;
    }

    state = (data_temp[1] << 8) + data_temp[0];
    Serial.print( ", States : ");
    Serial.print( state , HEX);

  }
}
